// speedextract.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//$GPRMC,055624.000,A,4846.5301,N,01125.4743,E,4.81,349.20,260607,,,A

#include "stdafx.h"
#include <string.h>

static double convert(double d) {
	d/=100;
	int p=(int)d;
	d=d-(double)p;
	return d/6*10+(double)p;
}

static double knots2kmh(double k) {
	return k*1.852;
}

const char pre[]= {"<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\
<kml xmlns=\"http://earth.google.com/kml/2.0\"><Document>\
<description>\
<![CDATA[This route was created by<br>Simons GPS Route Converter]]>\
</description>\
<Placemark><name>Route</name>\
<Style><LineStyle><color>8f007fff</color><width>3</width></LineStyle>\
<PolyStyle><color>4f0000ff</color></PolyStyle>\
<IconStyle><Icon></Icon></IconStyle></Style>\
<LineString>\
<extrude>1</extrude>\
<tessellate>1</tessellate>\
<altitudeMode>relativeToGround</altitudeMode>\
<coordinates>"};

const char post[]= {"</coordinates>\
</LineString></Placemark>\
</Document></kml>"};


int main(int argc, char* argv[])
{
	if (argc < 2) {
		printf("usage %s infile", argv[0]);
		return -1;
	}
	FILE *f;
	char buf[1024], mode=argv[1][0], c1,c2,c3,c4;
	float hd, spd, d1,d2,d3,d4;
	if (f = fopen(argv[1], "r")) {
		printf("%s\n", pre);
		while (!feof(f)) {
			fgets(buf, 1024, f);
			spd=0;
			if (strlen(buf)>10 && buf[0]=='$' && buf[3]=='R' && buf[4]=='M' && buf[5]=='C') {
				sscanf(buf, "$GPRMC,%f,%c,%f,%c,%f,%c,%f,%f,%f,,,%c", &d1, &c1, &d2, &c2, &d3, &c3, &spd, &hd, &d4, &c4);
				printf("%3.6f,%3.6f,%3.2f\n", convert(d3), convert(d2), knots2kmh(spd));
			}
		}
		fclose(f);
		printf("%s\n", post);
	}
	return 0;
}


